Index: /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limthd_dh.F90
===================================================================
--- /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limthd_dh.F90	(revision 3937)
+++ /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limthd_dh.F90	(revision 3938)
@@ -24,4 +24,5 @@
    USE lib_mpp          ! MPP library
    USE wrk_nemo         ! work arrays
+   USE lib_fortran      ! to use key_nosignedzero
 
    IMPLICIT NONE
@@ -72,8 +73,9 @@
       INTEGER  ::   ji , jk        ! dummy loop indices
       INTEGER  ::   zji, zjj       ! 2D corresponding indices to ji
-      INTEGER  ::   isnow          ! switch for presence (1) or absence (0) of snow
-      INTEGER  ::   isnowic        ! snow ice formation not
-      INTEGER  ::   i_ice_switch   ! ice thickness above a certain treshold or not
       INTEGER  ::   iter
+
+      REAL(wp) ::   isnow          ! switch for presence (1) or absence (0) of snow
+      REAL(wp) ::   isnowic        ! snow ice formation not
+      REAL(wp) ::   i_ice_switch   ! ice thickness above a certain treshold or not
 
       REAL(wp) ::   zzfmass_i, zihgnew                     ! local scalar
@@ -118,4 +120,8 @@
       REAL(wp), POINTER, DIMENSION(:,:) ::   zqt_i_lay   ! total ice heat content
 
+      ! mass and salt flux (clem)
+      REAL(wp) :: zdvres
+      REAL(wp), POINTER, DIMENSION(:) ::   zviold, zvsold   ! old ice volume...
+
       ! Heat conservation 
       INTEGER  ::   num_iter_max, numce_dh
@@ -130,12 +136,19 @@
       CALL wrk_alloc( jpij, jkmax, zdeltah, zqt_i_lay )
 
+      CALL wrk_alloc( jpij, zviold, zvsold ) ! clem
+      
       zfsalt_melt(:)  = 0._wp
       ftotal_fin(:)   = 0._wp
       zfdt_init(:)    = 0._wp
       zfdt_final(:)   = 0._wp
+      dh_i_surf(:)    = 0._wp
+      dh_i_bott(:)    = 0._wp
+      dh_snowice(:)    = 0._wp
 
       DO ji = kideb, kiut
          old_ht_i_b(ji) = ht_i_b(ji)
          old_ht_s_b(ji) = ht_s_b(ji)
+         zviold(ji) = a_i_b(ji) * ht_i_b(ji) ! clem
+         zvsold(ji) = a_i_b(ji) * ht_s_b(ji) ! clem
       END DO
       !
@@ -145,5 +158,5 @@
       !
       DO ji = kideb, kiut
-         isnow         = INT( 1.0 - MAX ( 0.0 , SIGN ( 1.0 , - ht_s_b(ji) ) ) )
+         isnow         = 1.0 - MAX ( 0.0 , SIGN ( 1.0 , - ht_s_b(ji) ) )
          ztfs(ji)      = isnow * rtt + ( 1.0 - isnow ) * rtt
          z_f_surf(ji)  = qnsr_ice_1d(ji) + ( 1.0 - i0(ji) ) * qsr_ice_1d(ji) - fc_su(ji)
@@ -162,6 +175,6 @@
       !
       DO ji = kideb, kiut     ! Layer thickness
-         zh_i(ji) = ht_i_b(ji) / nlay_i
-         zh_s(ji) = ht_s_b(ji) / nlay_s
+         zh_i(ji) = ht_i_b(ji) / REAL( nlay_i )
+         zh_s(ji) = ht_s_b(ji) / REAL( nlay_s )
       END DO
       !
@@ -169,5 +182,5 @@
       DO jk = 1, nlay_s
          DO ji = kideb, kiut
-            zqt_s(ji) =  zqt_s(ji) + q_s_b(ji,jk) * ht_s_b(ji) / nlay_s
+            zqt_s(ji) =  zqt_s(ji) + q_s_b(ji,jk) * ht_s_b(ji) / REAL( nlay_s )
          END DO
       END DO
@@ -176,5 +189,5 @@
       DO jk = 1, nlay_i
          DO ji = kideb, kiut
-            zzc = q_i_b(ji,jk) * ht_i_b(ji) / nlay_i
+            zzc = q_i_b(ji,jk) * ht_i_b(ji) / REAL( nlay_i )
             zqt_i(ji)        =  zqt_i(ji) + zzc
             zqt_i_lay(ji,jk) =              zzc
@@ -243,7 +256,8 @@
          ht_s_b(ji)     =  MAX( zzero , zhsnew )
          ! Volume and mass variations of snow
-         dvsbq_1d  (ji) =  a_i_b(ji) * ( ht_s_b(ji) - zhsold(ji) - zdh_s_mel(ji) )
+         ! dvsbq_1d  (ji) =  a_i_b(ji) * ( ht_s_b(ji) - zhsold(ji) - zdh_s_mel(ji) )
+         dvsbq_1d  (ji) =  a_i_b(ji) * ( ht_s_b(ji) - zhsold(ji) - zdh_s_pre(ji) )   ! IOVINO
          dvsbq_1d  (ji) =  MIN( zzero, dvsbq_1d(ji) )
-         rdmsnif_1d(ji) =  rdmsnif_1d(ji) + rhosn * dvsbq_1d(ji)
+         !clem rdmsnif_1d(ji) =  rdmsnif_1d(ji) + rhosn * dvsbq_1d(ji)
       END DO ! ji
 
@@ -252,5 +266,4 @@
       !--------------------------
       DO ji = kideb, kiut 
-         dh_i_surf(ji) =  0._wp
          z_f_surf (ji) =  zqfont_su(ji) / rdt_ice ! heat conservation test
          zdq_i    (ji) =  0._wp
@@ -270,9 +283,9 @@
             zdq_i    (ji)    = zdq_i(ji) + zdeltah(ji,jk) * q_i_b(ji,jk) / rdt_ice
             !
-            ! contribution to ice-ocean salt flux 
-            zji = MOD( npb(ji) - 1 , jpi ) + 1
-            zjj =    ( npb(ji) - 1 ) / jpi + 1
-            zfsalt_melt(ji) = zfsalt_melt(ji) + ( sss_m(zji,zjj) - sm_i_b(ji) ) * a_i_b(ji)    &
-               &                              * MIN( zdeltah(ji,jk) , 0.e0 ) * rhoic / rdt_ice 
+            ! IOVINO
+            !zfsalt_melt(ji) = zfsalt_melt(ji) - sm_i_b(ji) * a_i_b(ji)    &
+            !   &                              * MIN( zdeltah(ji,jk) , 0.e0 ) * rhoic / rdt_ice
+            fseqv_1d(ji) = fseqv_1d(ji) - sm_i_b(ji) * a_i_b(ji)    &
+               &                              * MIN( zdeltah(ji,jk) , 0._wp ) * rhoic / rdt_ice
          END DO
       END DO
@@ -331,5 +344,5 @@
          DO ji = kideb,kiut
             q_s_b    (ji,jk) = rhosn * ( cpic * ( rtt - t_s_b(ji,jk) ) + lfus )
-            zqt_dummy(ji)    =  zqt_dummy(ji) + q_s_b(ji,jk) * ht_s_b(ji) / nlay_s            ! heat conservation
+            zqt_dummy(ji)    =  zqt_dummy(ji) + q_s_b(ji,jk) * ht_s_b(ji) / REAL( nlay_s )            ! heat conservation
          END DO
       END DO
@@ -372,4 +385,5 @@
                ! Basal growth rate = - F*dt / q
                dh_i_bott(ji)       =  - rdt_ice*( fc_bo_i(ji) + fbif_1d(ji) + qlbbq_1d(ji) ) / q_i_b(ji,nlay_i+1) 
+               fseqv_1d(ji) = fseqv_1d(ji) - s_i_new(ji) * a_i_b(ji) * dh_i_bott(ji) * rhoic / rdt_ice
             ENDIF
          END DO
@@ -437,4 +451,5 @@
                dsm_i_se_1d(ji) = ( s_i_new(ji) * dh_i_bott(ji) + sm_i_b(ji) * ht_i_b(ji) )    &
                   &            / MAX( ht_i_b(ji) + dh_i_bott(ji) ,epsi13 ) - sm_i_b(ji)
+               fseqv_1d(ji) = fseqv_1d(ji) - s_i_new(ji) * a_i_b(ji) * dh_i_bott(ji) * rhoic / rdt_ice
             ENDIF ! heat budget
          END DO
@@ -473,10 +488,10 @@
                   dh_i_bott(ji)   = dh_i_bott(ji) + zdeltah(ji,jk)
                   zdq_i(ji)       = zdq_i(ji) + zdeltah(ji,jk) * q_i_b(ji,jk) / rdt_ice
-                  ! contribution to salt flux
-                  zji             = MOD( npb(ji) - 1, jpi ) + 1
-                  zjj             = ( npb(ji) - 1 ) / jpi + 1
-                  zfsalt_melt(ji) = zfsalt_melt(ji) + ( sss_m(zji,zjj) - sm_i_b(ji)   ) * a_i_b(ji)   &
-                     &                              * MIN( zdeltah(ji,jk) , 0.0 ) * rhoic / rdt_ice 
                ENDIF
+               ! IOVINO contribution to salt flux
+               !zfsalt_melt(ji) = zfsalt_melt(ji) - sm_i_b(ji) * a_i_b(ji)   &
+               !     &                              * MIN( zdeltah(ji,jk) , 0._wp ) * rhoic / rdt_ice
+               fseqv_1d(ji) = fseqv_1d(ji) - sm_i_b(ji) * a_i_b(ji)    &
+                    &                              * MIN( zdeltah(ji,jk) , 0._wp ) * rhoic / rdt_ice
             ENDIF
          END DO ! ji
@@ -529,18 +544,13 @@
          ELSE                  ;   zdhbf =              dh_i_bott(ji) 
          ENDIF
+         zdvres        = zdhbf - dh_i_bott(ji)
+         dh_i_bott(ji) = zdhbf
+         fseqv_1d(ji)  = fseqv_1d(ji) - sm_i_b(ji) * a_i_b(ji) * zdvres * rhoic / rdt_ice
          !                     ! excessive energy is sent to lateral ablation
-         fsup     (ji) =  rhoic * lfus * at_i_b(ji) / MAX( 1.0 - at_i_b(ji) , epsi13 )   &
-            &                          * ( zdhbf - dh_i_bott(ji) ) / rdt_ice
-         dh_i_bott(ji)  = zdhbf
+         fsup     (ji) =  rhoic * lfus * at_i_b(ji) / MAX( 1.0 - at_i_b(ji) , epsi13 ) * zdvres / rdt_ice
          !                     !since ice volume is only used for outputs, we keep it global for all categories
          dvbbq_1d (ji) = a_i_b(ji) * dh_i_bott(ji)
          !                     !new ice thickness
          zhgnew   (ji) = ht_i_b(ji) + dh_i_surf(ji) + dh_i_bott(ji)
-         !                     ! diagnostic ( bottom ice growth )
-         zji = MOD( npb(ji) - 1, jpi ) + 1
-         zjj = ( npb(ji) - 1 ) / jpi + 1
-         diag_bot_gr(zji,zjj) = diag_bot_gr(zji,zjj) + MAX(dh_i_bott(ji),0.0)*a_i_b(ji) / rdt_ice
-         diag_sur_me(zji,zjj) = diag_sur_me(zji,zjj) + MIN(dh_i_surf(ji),0.0)*a_i_b(ji) / rdt_ice
-         diag_bot_me(zji,zjj) = diag_bot_me(zji,zjj) + MIN(dh_i_bott(ji),0.0)*a_i_b(ji) / rdt_ice
       END DO
 
@@ -554,6 +564,7 @@
          ! Adapt the remaining energy if too much ice melts
          !--------------------------------------------------
+         zdvres     = MAX( 0._wp, - zhgnew(ji) )
          zihgnew    =  1.0 - MAX( zzero , SIGN( zone , - zhgnew(ji) ) ) !1 if ice
-         ! 0 if no more ice
+         dh_i_bott (ji) = dh_i_bott(ji) + zdvres ! clem@bug
          zhgnew    (ji) =         zihgnew   * zhgnew(ji)      ! ice thickness is put to 0
          ! remaining heat
@@ -581,11 +592,18 @@
          !
          !                                              ! mass variation cumulated over category
-         rdmsnif_1d(ji) = rdmsnif_1d(ji) + zzfmass_s                     ! snow 
-         rdmicif_1d(ji) = rdmicif_1d(ji) + zzfmass_i                     ! ice 
+         !clem rdmsnif_1d(ji) = rdmsnif_1d(ji) + zzfmass_s                     ! snow 
+         !clem rdmicif_1d(ji) = rdmicif_1d(ji) + zzfmass_i                     ! ice 
 
          ! Remaining heat to the ocean 
          !---------------------------------
          focea(ji)  = - zfdt_final(ji) / rdt_ice         ! focea is in W.m-2 * dt
-
+         ! salt flux
+         fseqv_1d(ji)  = fseqv_1d(ji) - sm_i_b(ji) * a_i_b(ji) * zdvres * rhoic / rdt_ice
+         !                     ! diagnostic ( bottom ice growth )
+         zji = MOD( npb(ji) - 1, jpi ) + 1
+         zjj = ( npb(ji) - 1 ) / jpi + 1
+         diag_bot_gr(zji,zjj) = diag_bot_gr(zji,zjj) + MAX(dh_i_bott(ji),0.0)*a_i_b(ji) / rdt_ice
+         diag_sur_me(zji,zjj) = diag_sur_me(zji,zjj) + MIN(dh_i_surf(ji),0.0)*a_i_b(ji) / rdt_ice
+         diag_bot_me(zji,zjj) = diag_bot_me(zji,zjj) + MIN(dh_i_bott(ji),0.0)*a_i_b(ji) / rdt_ice
       END DO
 
@@ -602,11 +620,13 @@
          zjj = ( npb(ji) - 1 ) / jpi + 1
          ! new lines
-         IF( num_sal == 4 ) THEN
-            fseqv_1d(ji) = fseqv_1d(ji) +        zihgnew  * zfsalt_melt(ji)                                &
-               &                        + (1.0 - zihgnew) * zfmass_i(ji) * ( sss_m(zji,zjj) - bulk_sal   ) / rdt_ice
-         ELSE
-            fseqv_1d(ji) = fseqv_1d(ji) +        zihgnew  * zfsalt_melt(ji)                                &
-               &                        + (1.0 - zihgnew) * zfmass_i(ji) * ( sss_m(zji,zjj) - sm_i_b(ji) ) / rdt_ice
-         ENDIF
+         !IF( num_sal == 4 ) THEN
+         !   ! IOVINO
+         !   fseqv_1d(ji) = fseqv_1d(ji) +        zihgnew  * zfsalt_melt(ji)                                &
+         !      &                        - (1.0 - zihgnew) * zfmass_i(ji) * bulk_sal / rdt_ice
+         !ELSE
+         !   ! IOVINO
+         !   fseqv_1d(ji) = fseqv_1d(ji) +        zihgnew  * zfsalt_melt(ji)                                &
+         !      &                        - (1.0 - zihgnew) * zfmass_i(ji) * sm_i_b(ji) / rdt_ice 
+         !ENDIF
          ! Heat flux
          ! excessive bottom ablation energy (fsup) - 0 except if jpl = 1
@@ -619,4 +639,9 @@
          qldif_1d(ji)  = qldif_1d(ji) + fsup(ji) + ( 1.0 - zihgnew ) * focea(ji)    * a_i_b(ji) * rdt_ice   &
             &                                    + ( 1.0 - zihic   ) * fscbq_1d(ji)             * rdt_ice
+         !IF ( (zji.eq.jiindx).AND.(zjj.eq.jjindx) ) THEN
+         !   !clemclem
+         !   WRITE(numout,*) 'lim_thd_dh : qldif = ', qldif_1d(ji)
+         !   !clemclem
+         !ENDIF
       END DO  ! ji
 
@@ -656,6 +681,6 @@
          dmgwi_1d  (ji) = dmgwi_1d(ji) + a_i_b(ji) * ( ht_s_b(ji) - zhnnew ) * rhosn
 
-         rdmicif_1d(ji) = rdmicif_1d(ji) + a_i_b(ji) * ( zhgnew(ji) - ht_i_b(ji) ) * rhoic 
-         rdmsnif_1d(ji) = rdmsnif_1d(ji) + a_i_b(ji) * ( zhnnew     - ht_s_b(ji) ) * rhosn
+         !clem rdmicif_1d(ji) = rdmicif_1d(ji) + a_i_b(ji) * ( zhgnew(ji) - ht_i_b(ji) ) * rhoic 
+         !clem rdmsnif_1d(ji) = rdmsnif_1d(ji) + a_i_b(ji) * ( zhnnew     - ht_s_b(ji) ) * rhosn 
 
          !        Equivalent salt flux (1) Snow-ice formation component
@@ -667,18 +692,22 @@
          ELSE                      ;   zsm_snowice = ( rhoic - rhosn ) / rhoic * sss_m(zji,zjj) 
          ENDIF
-         IF( num_sal == 4 ) THEN
-            fseqv_1d(ji) = fseqv_1d(ji) + ( sss_m(zji,zjj) - bulk_sal    ) * a_i_b(ji)   &
-               &                        * ( zhgnew(ji) - ht_i_b(ji) ) * rhoic / rdt_ice
-         ELSE
-            fseqv_1d(ji) = fseqv_1d(ji) + ( sss_m(zji,zjj) - zsm_snowice ) * a_i_b(ji)   &
-               &                        * ( zhgnew(ji) - ht_i_b(ji) ) * rhoic / rdt_ice
-         ENDIF
+         !IF( num_sal == 4 ) THEN  
+         !   ! IOVINO
+         !   fseqv_1d(ji) = fseqv_1d(ji) - bulk_sal * a_i_b(ji) * dh_snowice(ji) * rhoic / rdt_ice
+         !ELSE
+         !   ! IOVINO
+         !   fseqv_1d(ji) = fseqv_1d(ji) - zsm_snowice * a_i_b(ji) * dh_snowice(ji) * rhoic / rdt_ice
+         !ENDIF
          ! entrapment during snow ice formation
-         i_ice_switch = 1.0 - MAX( 0.e0 , SIGN( 1.0 , - ht_i_b(ji) + 1.0e-6 ) )
-         isnowic      = 1.0 - MAX( 0.e0 , SIGN( 1.0 , - dh_snowice(ji)      ) ) * i_ice_switch
-         IF(  num_sal == 2  .OR.  num_sal == 4  )   &
-            dsm_i_si_1d(ji) = ( zsm_snowice*dh_snowice(ji) &
-            &               + sm_i_b(ji) * ht_i_b(ji) / MAX( ht_i_b(ji) + dh_snowice(ji), epsi13)   &
-            &               - sm_i_b(ji) ) * isnowic     
+         i_ice_switch = 1.0 - MAX( 0.e0 , SIGN( 1.0 , - ht_i_b(ji) + epsi13 ) )
+         isnowic      = 1.0 - MAX( 0.e0 , SIGN( 1.0 , - dh_snowice(ji) ) ) * i_ice_switch
+
+         !clem IF(  num_sal == 2  .OR.  num_sal == 4  )   &
+         !clem   dsm_i_si_1d(ji) = ( zsm_snowice*dh_snowice(ji) &
+         !clem   &               + sm_i_b(ji) * ht_i_b(ji) / MAX( ht_i_b(ji) + dh_snowice(ji), epsi13)   &
+         !clem   &               - sm_i_b(ji) ) * isnowic
+         IF (  num_sal == 2  .OR.  num_sal == 4  )   &
+            & dsm_i_si_1d(ji) = ( ( zsm_snowice * dh_snowice(ji) + sm_i_b(ji) * ht_i_b(ji) ) &
+            &                    / MAX( ht_i_b(ji) + dh_snowice(ji), epsi13 ) - sm_i_b(ji) ) * isnowic     
 
          !  Actualize new snow and ice thickness.
@@ -693,5 +722,13 @@
          zjj =    ( npb(ji) - 1 ) / jpi + 1
          diag_sni_gr(zji,zjj)  = diag_sni_gr(zji,zjj) + dh_snowice(ji)*a_i_b(ji) / rdt_ice
-         !
+
+         ! salt flux
+         fseqv_1d(ji) = fseqv_1d(ji) - zsm_snowice * a_i_b(ji) * dh_snowice(ji) * rhoic / rdt_ice
+         !--------------------------------
+         ! Update mass fluxes (clem)
+         !--------------------------------
+         rdmicif_1d(ji) = rdmicif_1d(ji) + ( a_i_b(ji) * ht_i_b(ji) - zviold(ji) ) * rhoic 
+         rdmsnif_1d(ji) = rdmsnif_1d(ji) + ( a_i_b(ji) * ht_s_b(ji) - zvsold(ji) ) * rhosn 
+
       END DO !ji
       !
@@ -700,4 +737,6 @@
       CALL wrk_dealloc( jpij, zinnermelt, zfbase, zdq_i )
       CALL wrk_dealloc( jpij, jkmax, zdeltah, zqt_i_lay )
+      !
+      CALL wrk_dealloc( jpij, zviold, zvsold ) ! clem
       !
    END SUBROUTINE lim_thd_dh
Index: /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limthd_dif.F90
===================================================================
--- /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limthd_dif.F90	(revision 3937)
+++ /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limthd_dif.F90	(revision 3938)
@@ -10,4 +10,5 @@
    !!                 ! 04-2007 (M. Vancoppenolle) Energy conservation
    !!            4.0  ! 2011-02 (G. Madec) dynamical allocation
+   !!             -   ! 2012-05 (C. Rousset) add penetration solar flux
    !!----------------------------------------------------------------------
 #if defined key_lim3
@@ -23,4 +24,5 @@
    USE lib_mpp          ! MPP library
    USE wrk_nemo         ! work arrays
+   USE lib_fortran      ! to use key_nosignedzero
 
    IMPLICIT NONE
@@ -102,7 +104,44 @@
       INTEGER ::   nconv       ! number of iterations in iterative procedure
       INTEGER ::   minnumeqmin, maxnumeqmax
-      INTEGER, DIMENSION(kiut) ::   numeqmin   ! reference number of top equation
-      INTEGER, DIMENSION(kiut) ::   numeqmax   ! reference number of bottom equation
-      INTEGER, DIMENSION(kiut) ::   isnow      ! switch for presence (1) or absence (0) of snow
+
+      INTEGER , DIMENSION(kiut) ::   numeqmin   ! reference number of top equation
+      INTEGER , DIMENSION(kiut) ::   numeqmax   ! reference number of bottom equation
+      INTEGER , DIMENSION(kiut) ::   isnow      ! switch for presence (1) or absence (0) of snow
+
+      !! * New local variables       
+      REAL(wp), DIMENSION(kiut,0:nlay_i) ::   ztcond_i   !Ice thermal conductivity
+      REAL(wp), DIMENSION(kiut,0:nlay_i) ::   zradtr_i   !Radiation transmitted through the ice
+      REAL(wp), DIMENSION(kiut,0:nlay_i) ::   zradab_i   !Radiation absorbed in the ice
+      REAL(wp), DIMENSION(kiut,0:nlay_i) ::   zkappa_i   !Kappa factor in the ice
+
+      REAL(wp), DIMENSION(kiut,0:nlay_s) ::   zradtr_s   !Radiation transmited through the snow
+      REAL(wp), DIMENSION(kiut,0:nlay_s) ::   zradab_s   !Radiation absorbed in the snow
+      REAL(wp), DIMENSION(kiut,0:nlay_s) ::   zkappa_s   !Kappa factor in the snow
+
+      REAL(wp), DIMENSION(kiut,0:nlay_i) ::   ztiold      !Old temperature in the ice
+      REAL(wp), DIMENSION(kiut,0:nlay_i) ::   zeta_i      !Eta factor in the ice 
+      REAL(wp), DIMENSION(kiut,0:nlay_i) ::   ztitemp     !Temporary temperature in the ice to check the convergence
+      REAL(wp), DIMENSION(kiut,0:nlay_i) ::   zspeche_i   !Ice specific heat
+      REAL(wp), DIMENSION(kiut,0:nlay_i) ::   z_i         !Vertical cotes of the layers in the ice
+
+      REAL(wp), DIMENSION(kiut,0:nlay_s) ::   zeta_s      !Eta factor in the snow
+      REAL(wp), DIMENSION(kiut,0:nlay_s) ::   ztstemp     !Temporary temperature in the snow to check the convergence
+      REAL(wp), DIMENSION(kiut,0:nlay_s) ::   ztsold      !Temporary temperature in the snow
+      REAL(wp), DIMENSION(kiut,0:nlay_s) ::   z_s         !Vertical cotes of the layers in the snow
+
+      REAL(wp), DIMENSION(kiut,jkmax+2)   ::   zindterm    ! Independent term
+      REAL(wp), DIMENSION(kiut,jkmax+2)   ::   zindtbis    ! temporary independent term
+      REAL(wp), DIMENSION(kiut,jkmax+2)   ::   zdiagbis
+      REAL(wp), DIMENSION(kiut,jkmax+2,3) ::   ztrid       ! tridiagonal system terms
+
+      REAL(wp), DIMENSION(kiut) ::   ztfs        ! ice melting point
+      REAL(wp), DIMENSION(kiut) ::   ztsuold     ! old surface temperature (before the iterative procedure )
+      REAL(wp), DIMENSION(kiut) ::   ztsuoldit   ! surface temperature at previous iteration
+      REAL(wp), DIMENSION(kiut) ::   zh_i        ! ice layer thickness
+      REAL(wp), DIMENSION(kiut) ::   zh_s        ! snow layer thickness
+      REAL(wp), DIMENSION(kiut) ::   zfsw        ! solar radiation absorbed at the surface
+      REAL(wp), DIMENSION(kiut) ::   zf          ! surface flux function
+      REAL(wp), DIMENSION(kiut) ::   dzf         ! derivative of the surface flux function
+
       REAL(wp) ::   zeps      =  1.e-10_wp    !
       REAL(wp) ::   zg1s      =  2._wp        ! for the tridiagonal system
@@ -113,41 +152,13 @@
       REAL(wp) ::   zkimin    =  0.10_wp      ! minimum ice thermal conductivity
       REAL(wp) ::   zht_smin  =  1.e-4_wp     ! minimum snow depth
+
       REAL(wp) ::   ztmelt_i    ! ice melting temperature
       REAL(wp) ::   zerritmax   ! current maximal error on temperature 
-      REAL(wp), DIMENSION(kiut) ::   ztfs        ! ice melting point
-      REAL(wp), DIMENSION(kiut) ::   ztsuold     ! old surface temperature (before the iterative procedure )
-      REAL(wp), DIMENSION(kiut) ::   ztsuoldit   ! surface temperature at previous iteration
-      REAL(wp), DIMENSION(kiut) ::   zh_i        ! ice layer thickness
-      REAL(wp), DIMENSION(kiut) ::   zh_s        ! snow layer thickness
-      REAL(wp), DIMENSION(kiut) ::   zfsw        ! solar radiation absorbed at the surface
-      REAL(wp), DIMENSION(kiut) ::   zf          ! surface flux function
-      REAL(wp), DIMENSION(kiut) ::   dzf         ! derivative of the surface flux function
-      REAL(wp), DIMENSION(kiut) ::   zerrit      ! current error on temperature
-      REAL(wp), DIMENSION(kiut) ::   zdifcase    ! case of the equation resolution (1->4)
-      REAL(wp), DIMENSION(kiut) ::   zftrice     ! solar radiation transmitted through the ice
+      REAL(wp), DIMENSION(kiut) ::   zerrit       ! current error on temperature 
+      REAL(wp), DIMENSION(kiut) ::   zdifcase     ! case of the equation resolution (1->4)
+      REAL(wp), DIMENSION(kiut) ::   zftrice      ! solar radiation transmitted through the ice
       REAL(wp), DIMENSION(kiut) ::   zihic, zhsu
-      REAL(wp), DIMENSION(kiut,0:nlay_i) ::   ztcond_i    ! Ice thermal conductivity
-      REAL(wp), DIMENSION(kiut,0:nlay_i) ::   zradtr_i    ! Radiation transmitted through the ice
-      REAL(wp), DIMENSION(kiut,0:nlay_i) ::   zradab_i    ! Radiation absorbed in the ice
-      REAL(wp), DIMENSION(kiut,0:nlay_i) ::   zkappa_i    ! Kappa factor in the ice
-      REAL(wp), DIMENSION(kiut,0:nlay_i) ::   ztiold      ! Old temperature in the ice
-      REAL(wp), DIMENSION(kiut,0:nlay_i) ::   zeta_i      ! Eta factor in the ice
-      REAL(wp), DIMENSION(kiut,0:nlay_i) ::   ztitemp     ! Temporary temperature in the ice to check the convergence
-      REAL(wp), DIMENSION(kiut,0:nlay_i) ::   zspeche_i   ! Ice specific heat
-      REAL(wp), DIMENSION(kiut,0:nlay_i) ::   z_i         ! Vertical cotes of the layers in the ice
-      REAL(wp), DIMENSION(kiut,0:nlay_s) ::   zradtr_s    ! Radiation transmited through the snow
-      REAL(wp), DIMENSION(kiut,0:nlay_s) ::   zradab_s    ! Radiation absorbed in the snow
-      REAL(wp), DIMENSION(kiut,0:nlay_s) ::   zkappa_s    ! Kappa factor in the snow
-      REAL(wp), DIMENSION(kiut,0:nlay_s) ::   zeta_s       ! Eta factor in the snow
-      REAL(wp), DIMENSION(kiut,0:nlay_s) ::   ztstemp      ! Temporary temperature in the snow to check the convergence
-      REAL(wp), DIMENSION(kiut,0:nlay_s) ::   ztsold       ! Temporary temperature in the snow
-      REAL(wp), DIMENSION(kiut,0:nlay_s) ::   z_s          ! Vertical cotes of the layers in the snow
-      REAL(wp), DIMENSION(kiut,jkmax+2) ::   zindterm   ! Independent term
-      REAL(wp), DIMENSION(kiut,jkmax+2) ::   zindtbis   ! temporary independent term
-      REAL(wp), DIMENSION(kiut,jkmax+2) ::   zdiagbis
-      REAL(wp), DIMENSION(kiut,jkmax+2,3) ::   ztrid   ! tridiagonal system terms
       !!------------------------------------------------------------------
-      
-      ! 
+      !
       !------------------------------------------------------------------------------!
       ! 1) Initialization                                                            !
@@ -156,11 +167,11 @@
       DO ji = kideb , kiut
          ! is there snow or not
-         isnow(ji)= INT(  1._wp - MAX( 0._wp , SIGN(1._wp, - ht_s_b(ji) ) )  )
+         isnow(ji)= NINT(  1._wp - MAX( 0._wp , SIGN(1._wp, - ht_s_b(ji) ) )  )
          ! surface temperature of fusion
 !!gm ???  ztfs(ji) = rtt !!!????
-         ztfs(ji) = isnow(ji) * rtt + (1.0-isnow(ji)) * rtt
+         ztfs(ji) = REAL( isnow(ji) ) * rtt + REAL( 1 - isnow(ji) ) * rtt
          ! layer thickness
-         zh_i(ji) = ht_i_b(ji) / nlay_i
-         zh_s(ji) = ht_s_b(ji) / nlay_s
+         zh_i(ji) = ht_i_b(ji) / REAL( nlay_i )
+         zh_s(ji) = ht_s_b(ji) / REAL( nlay_s )
       END DO
 
@@ -174,5 +185,5 @@
       DO layer = 1, nlay_s            ! vert. coord of the up. lim. of the layer-th snow layer
          DO ji = kideb , kiut
-            z_s(ji,layer) = z_s(ji,layer-1) + ht_s_b(ji) / nlay_s
+            z_s(ji,layer) = z_s(ji,layer-1) + ht_s_b(ji) / REAL( nlay_s )
          END DO
       END DO
@@ -180,5 +191,5 @@
       DO layer = 1, nlay_i            ! vert. coord of the up. lim. of the layer-th ice layer
          DO ji = kideb , kiut
-            z_i(ji,layer) = z_i(ji,layer-1) + ht_i_b(ji) / nlay_i
+            z_i(ji,layer) = z_i(ji,layer-1) + ht_i_b(ji) / REAL( nlay_i )
          END DO
       END DO
@@ -201,10 +212,10 @@
       DO ji = kideb , kiut
          ! switches
-         isnow(ji) = INT(  1._wp - MAX( 0._wp , SIGN( 1._wp , - ht_s_b(ji) ) )  ) 
+         isnow(ji) = NINT(  1._wp - MAX( 0._wp , SIGN( 1._wp , - ht_s_b(ji) ) )  ) 
          ! hs > 0, isnow = 1
          zhsu (ji) = hnzst  ! threshold for the computation of i0
          zihic(ji) = MAX( 0._wp , 1._wp - ( ht_i_b(ji) / zhsu(ji) ) )     
 
-         i0(ji)    = ( 1._wp - isnow(ji) ) * ( fr1_i0_1d(ji) + zihic(ji) * fr2_i0_1d(ji) )
+         i0(ji)    = REAL( 1 - isnow(ji) ) * ( fr1_i0_1d(ji) + zihic(ji) * fr2_i0_1d(ji) )
          !fr1_i0_1d = i0 for a thin ice surface
          !fr1_i0_2d = i0 for a thick ice surface
@@ -243,5 +254,5 @@
 
       DO ji = kideb, kiut           ! ice initialization
-         zradtr_i(ji,0) = zradtr_s(ji,nlay_s) * isnow(ji) + zftrice(ji) * ( 1._wp - isnow(ji) )
+         zradtr_i(ji,0) = zradtr_s(ji,nlay_s) * REAL( isnow(ji) ) + zftrice(ji) * REAL( 1 - isnow(ji) )
       END DO
 
@@ -256,5 +267,5 @@
 
       DO ji = kideb, kiut           ! Radiation transmitted below the ice
-         fstbif_1d(ji) = fstbif_1d(ji) + zradtr_i(ji,nlay_i) * a_i_b(ji) / at_i_b(ji)
+         fstbif_1d(ji) = fstbif_1d(ji) + iatte_1d(ji) * zradtr_i(ji,nlay_i) * a_i_b(ji) / at_i_b(ji) ! clem modif
       END DO
 
@@ -264,5 +275,5 @@
          ii                = MOD( npb(ji) - 1, jpi ) + 1
          ij                = ( npb(ji) - 1 ) / jpi + 1
-         fstroc(ii,ij,jl) = zradtr_i(ji,nlay_i)
+         fstroc(ii,ij,jl) = iatte_1d(ji) * zradtr_i(ji,nlay_i) ! clem modif
       END DO
       ! +++++
@@ -273,5 +284,4 @@
          END DO
       END DO
-
 
       !
@@ -377,6 +387,6 @@
             zkappa_s(ji,nlay_s)   = 2.0*rcdsn*ztcond_i(ji,0)/MAX(zeps, &
                (ztcond_i(ji,0)*zh_s(ji) + rcdsn*zh_i(ji)))
-            zkappa_i(ji,0)        = zkappa_s(ji,nlay_s)*isnow(ji) &
-               + zkappa_i(ji,0)*(1.0-isnow(ji))
+            zkappa_i(ji,0)        = zkappa_s(ji,nlay_s)*REAL( isnow(ji) ) &
+               + zkappa_i(ji,0)*REAL( 1 - isnow(ji) )
          END DO
          !
@@ -659,12 +669,12 @@
                t_s_b(ji,nlay_s)     =  (zindtbis(ji,nlay_s+1) - ztrid(ji,nlay_s+1,3) &
                *  t_i_b(ji,1))/zdiagbis(ji,nlay_s+1) &
-               *        MAX(0.0,SIGN(1.0,ht_s_b(ji)-zeps)) 
+               *        MAX(0.0,SIGN(1.0,ht_s_b(ji))) 
 
             ! surface temperature
-            isnow(ji)     = INT(1.0-max(0.0,sign(1.0,-ht_s_b(ji))))
+            isnow(ji)     = NINT(1.0-max(0.0,SIGN(1.0,-ht_s_b(ji))))
             ztsuoldit(ji) = t_su_b(ji)
             IF (t_su_b(ji) .LT. ztfs(ji)) &
-               t_su_b(ji) = ( zindtbis(ji,numeqmin(ji)) - ztrid(ji,numeqmin(ji),3)* ( isnow(ji)*t_s_b(ji,1)   &
-               &          + (1.0-isnow(ji))*t_i_b(ji,1) ) ) / zdiagbis(ji,numeqmin(ji))  
+               t_su_b(ji) = ( zindtbis(ji,numeqmin(ji)) - ztrid(ji,numeqmin(ji),3)* ( REAL( isnow(ji) )*t_s_b(ji,1)   &
+               &          + REAL( 1 - isnow(ji) )*t_i_b(ji,1) ) ) / zdiagbis(ji,numeqmin(ji))  
          END DO
          !
@@ -718,9 +728,10 @@
       DO ji = kideb, kiut
          !                                ! update of latent heat fluxes
-         qla_ice_1d (ji) = qla_ice_1d (ji) + dqla_ice_1d(ji) * ( t_su_b(ji) - ztsuold(ji) )
+         ! qla_ice_1d (ji) =          qla_ice_1d (ji) + dqla_ice_1d(ji) * ( t_su_b(ji)! - ztsuold(ji) )     ! TECLIM change
+         qla_ice_1d (ji) = MAX( 0.e0, qla_ice_1d (ji) + dqla_ice_1d(ji) * (t_su_b(ji) - ztsuold(ji) ) )
          !                                ! surface ice conduction flux
-         isnow(ji)       = INT(  1._wp - MAX( 0._wp, SIGN( 1._wp, -ht_s_b(ji) ) )  )
-         fc_su(ji)       =  -           isnow(ji)   * zkappa_s(ji,0) * zg1s * (t_s_b(ji,1) - t_su_b(ji))   &
-            &               - ( 1._wp - isnow(ji) ) * zkappa_i(ji,0) * zg1  * (t_i_b(ji,1) - t_su_b(ji))
+         isnow(ji)       = NINT(  1._wp - MAX( 0._wp, SIGN( 1._wp, -ht_s_b(ji) ) )  )
+         fc_su(ji)       =  -     REAL( isnow(ji) ) * zkappa_s(ji,0) * zg1s * (t_s_b(ji,1) - t_su_b(ji))   &
+            &               - REAL( 1 - isnow(ji) ) * zkappa_i(ji,0) * zg1  * (t_i_b(ji,1) - t_su_b(ji))
          !                                ! bottom ice conduction flux
          fc_bo_i(ji)     =  - zkappa_i(ji,nlay_i) * ( zg1*(t_bo_b(ji) - t_i_b(ji,nlay_i)) )
@@ -733,12 +744,12 @@
          DO ji = kideb, kiut
             ! Upper snow value
-            fc_s(ji,0) = - isnow(ji) * zkappa_s(ji,0) * zg1s * ( t_s_b(ji,1) - t_su_b(ji) ) 
+            fc_s(ji,0) = - REAL( isnow(ji) ) * zkappa_s(ji,0) * zg1s * ( t_s_b(ji,1) - t_su_b(ji) ) 
             ! Bott. snow value
-            fc_s(ji,1) = - isnow(ji)* zkappa_s(ji,1) * ( t_i_b(ji,1) - t_s_b(ji,1) ) 
+            fc_s(ji,1) = - REAL( isnow(ji) ) * zkappa_s(ji,1) * ( t_i_b(ji,1) - t_s_b(ji,1) ) 
          END DO
          DO ji = kideb, kiut         ! Upper ice layer
-            fc_i(ji,0) = - isnow(ji) * &  ! interface flux if there is snow
+            fc_i(ji,0) = - REAL( isnow(ji) ) * &  ! interface flux if there is snow
                ( zkappa_i(ji,0)  * ( t_i_b(ji,1) - t_s_b(ji,nlay_s ) ) ) &
-               - ( 1.0 - isnow(ji) ) * ( zkappa_i(ji,0) * & 
+               - REAL( 1 - isnow(ji) ) * ( zkappa_i(ji,0) * & 
                zg1 * ( t_i_b(ji,1) - t_su_b(ji) ) ) ! upper flux if not
          END DO
@@ -755,4 +766,5 @@
       ENDIF
       !
+
    END SUBROUTINE lim_thd_dif
 
